//   FF_FP
//          .
//   :

//         Lot = MinLot * ( Sqrt [ 0.25 + 2 * ( Balance - Delta ) / Delta ] + 0.5 )

// Lot   ,
// MinLot -    ,
// Sqrt -  .
//   Delta = 10000       Balance = 10000     
//       

//                          n   | Balance
//                          -------------
//                          1   |   10000
//                          2   |   20000
//                          3   |   40000
//                          4   |   70000
//                          5   |  110000
//                          6   |  160000
//                          7   |  220000
//                          8   |  290000


//  n     .
//  Delta      Delta_Growth    ,    Delta
//   Delta_Decrease    
//  Delta_Growth  Delta_Decrease       .

//                
//   

//           Mathematical xpectation.

//      F  Optimum fraction  F  (   )

// Current Drowdown               
//                  
//     
// Net Profit today (%)     , Net Profit this week (%) -     Net Profit this month (%)
//   
//------------------------------------------------------------------------------------------------------------------ 
#property indicator_separate_window           //    
#property indicator_buffers 2                 //    
#property indicator_minimum 0                 //   
#property indicator_color1 LightSteelBlue     //     
#property indicator_color2 LightSlateGray     //     
#property indicator_levelcolor SlateGray      //   
#property indicator_style1 0                  //       
#property indicator_width1 1                  //      (    = 0 )
#property indicator_style2 2                  //       
#property indicator_width2 1                  //      (    = 0 )
#property indicator_levelstyle 0              //    
#property indicator_levelwidth 1              //   (    = 0 )
#property indicator_level1 0                  //   
//----  

    extern double Delta_Growth = 10;          //  Delta    
    extern double Delta_Decrease = 12;        //  Delta   
    extern bool Get_report = false;           //     => true /   => false
    extern int MA_period = 8;                 //    
    extern bool EMA_true_SMA_false = false;   //       EMA => true / SMA => false
//---------------------------------------------------------------------------------
      double T[2000];                         //       /   buy / sell
      double B[2000];                         //         , 
      double Buffer[];                        //    ( 2     
      double Buffer1[];                       //     )
//------------
      int init( )
      {
      IndicatorBuffers( 2 );
      IndicatorDigits( 2 ); 
      SetIndexStyle( 0, DRAW_HISTOGRAM );
      SetIndexStyle( 1, DRAW_LINE );
      SetIndexBuffer( 0, Buffer );
      SetIndexBuffer( 1, Buffer1 );
      string name = "Balance";
      string Method = "SMA";
      if( EMA_true_SMA_false == true )
      {
      Method = "EMA";
      }
      string name1 = "Average Balance  "+Method+" ("+MA_period+")";
      IndicatorShortName( name );
      SetIndexLabel( 0, name );
      SetIndexLabel( 1, name1 );
      return(0);
      }
//----
      int deinit( )
      {

      return(0);
      }
//----
      int start( )
      {
      double balance = AccountBalance( );
   	if( Get_report == true )
   	{			
      int i;
      int cmd;
      double swap;
      double commission;
      double orderprofit;
      string ordercomment;
      double loss;
      double profit;
      double nles;
      double nprofi;
      double Dd = 0;
      double s;
      double sum = 0;
      double sum1 = 0;
      double fs = 0;
      double Lp;
      double Ll;
      double u;
      int o1 = 0;
      int j = 0;
      double mk = 0;
      double en = 0;
      double b1 = 0;
      double b2 = 0;
      int y5;
      double SU = 0;
      double EJ = 0;
      int ii;
      int yy = 0;
      int xx = 0;
      int re;
      int es;
      double gb;
      double cn;
      double de3;
      int z = 0;
      double short;
      double long;
      int Total_short;
      int Total_long;
      double SOC;
      double C1;
      double NT1;
      double NW2;
      double NM3;
      int xc;
      datetime closetime;
      double ny;
      int w;

      while( i < OrdersHistoryTotal( ) )
      {
      if( OrderSelect( i, SELECT_BY_POS, MODE_HISTORY ) == true )
      {
      swap = OrderSwap( );
      closetime = OrderCloseTime( );
      cmd = OrderType( );
      commission = OrderCommission( );
      orderprofit = OrderProfit( );
      //----
      if( ( cmd != 2 ) && ( cmd != 3 ) && ( cmd != 4 ) && ( cmd != 5 ) )
      {
      xc++;                                                //      
      if( ( cmd == 6 ) && ( orderprofit > 0 ) )
      {
      b1 = b1 + orderprofit;                               //  / Deposit
      }
      else
      {
      if( ( cmd == 6 ) && ( orderprofit < 0 ) )
      {
      w = xc + 1;
      b2 = b2 + orderprofit;                               //  / Withdrawal
      }
      }
      //----
      C1 = swap + orderprofit + commission;
      de3 = de3 + C1;                                      // 
      B[xc] = de3;
      //------------------------------------------
      if( cmd <= 1 )
      {
      SOC = swap + orderprofit + commission;
      if( closetime >= iTime( NULL, PERIOD_D1, 0 ) )
      {
      NT1 = NT1 + SOC;                                     //  Net Profit today (%)
      } 
      if( closetime >= iTime( NULL, PERIOD_W1, 0 ) )
      {
      NW2 = NW2 + SOC;                                     //  Net Profit this week (%)
      }
      if( closetime >= iTime( NULL, PERIOD_MN1, 0 ) )
      {
      NM3 = NM3 + SOC;                                     //  Net Profit this month (%)
      }
      //----
      z++;                                                 //    buy / sell 
      T[z] = SOC;                                          //     
      if( SOC < 0 )
      {
      sum = sum + SOC;                                     //     
      o1++;                                                //   
      y5++;                                                //  .  .   Maximum consecutive losses
      if( mk > sum  )                                      // 
      {
      mk = sum;                                            // Maximal consecutive loss ( re )
      re = y5;                                             //   Maximal consecutive loss
      }
      if( xx <= y5 )
      {
      xx = y5;                                             //   xx  
      }
      if( Ll > SOC )
      {
      Ll = SOC;                                            //        Largest loss trade
      }
      nles++;                                              //   
      loss = loss - SOC;                                   //    Gross loss
      }
      else
      {
      if( SOC >= 0 )
      {
      if( cmd == 0 )
      {
      long++;                                              //      
      }                                                    //  Long profit trade
      else
      {
      if( cmd == 1 )
      {
      short++;                                             //      
      }                                                    //  Short profit trade
      }
      sum = 0;                                             //       
      if( o1 != 0 )
      {
      gb++;                                                //     
      }
      o1 = 0;                                              //    
      y5 = 0;                                              //  0      
      sum1 = sum1 + SOC;                                   // Maximal consecutive count / loss
      j++;                                                 //   
      ii++;                                                //  .  .   Maximum consecutive wins
      if( en < sum1 )                                      // 
      {
      en = sum1;                                           // Maximal consecutive profit ( es )
      es = ii;                                             //   Maximal consecutive profit
      }
      if( yy <= ii )
      {
      yy = ii;                                             //   yy  
      }
      if( Lp < SOC )
      {
      Lp = SOC;                                            //        Largest profit trade
      } 
      nprofi++;                                            //   
      profit = profit + SOC;                               //    Gross profit
      }
      }
      //---
      if( SOC < 0 )
      { 
      sum1 = 0;                                            //       
      if( j != 0 )
      {
      cn++;                                                //     
      }  
      j = 0;                                               //    
      ii = 0;                                              //       
      }                                                    // Maximal consecutive count / profit
      }                                                    //   if( cmd <= 1 )    
      //----
      if( cmd == 0 )
      {
      Total_long++;                                        //     
      }                                                    //  Long Positions
      else
      {
      if( cmd == 1 )
      {
      Total_short++;                                       //     
      }                                                    //  Short Positions 
      }
      //----
      }                                                    //   if( cmd != 2 && cmd != 3 && cmd != 4 && cmd != 5 )
      }                                                    //   if( OrderSelect( i, SELECT_BY_POS, MODE_HISTORY ) == true )
      i++;
      }                                                    //    while( i < OrdersHistoryTotal( ) ) 
      //                                                   //    Current Drowdown(%)
      int oi = 0;
      int maxindex = ArrayMaximum( B, xc, 0 );             //     
      double max = B[maxindex];                            //     
      while( oi <= xc - maxindex )                         //     xc - maxindex
      {
      static double min = 1000000;
      if( ( min > B[xc - oi] ) && ( xc - oi > w ) )        //         
      {                                                    //    Current Drowdown(%)
      min = B[xc - oi];                                    //   
      }
      oi++;                                                //  
      }
      Dd = max - min;                                   //     Current Drowdown   
      if( max != 0 )                                    //      .  
      {                                                 //        
      u = 100 * Dd / max;                               //   Current Drowdown  
      } 
      //        ,    Maximum consecutive wins ($)
      int ie = 0;                                //  Maximum consecutive losses ($) (     )
      int t = 0;
      int k2 = 0;
      double org = 0;
      double fgh = 0;
      double owq = 0;
      double css = 0;
      
      while( ie < xc )
      {
      if( ( T[ie] < 0 ) && ( t < xx ) )          //   
      {
      t++;
      SU = SU + T[ie];
      if( owq > SU )
      {
      owq = SU;
      if( t == xx )
      {
      css = owq;                                 //      
      }                                          //  
      }
      }
      else
      {
      if( ( T[ie] >= 0 ) && ( t < xx ) )
      {
      t = 0;
      SU = 0;
      }
      }
      if( t == xx )
      {
      t = 0;
      SU = 0;
      }
      //----
      if( ( T[ie] >= 0 ) && ( k2 < yy ) )       //  c 
      {
      k2++;
      EJ = EJ + T[ie];
      if( org < EJ )
      {
      org = EJ;
      if( k2 == yy )
      {
      fgh = org;                                //      
      }                                         //  
      }
      }
      else
      {
      if( ( T[ie] < 0 ) && ( k2 < yy ) )
      {
      k2 = 0;
      EJ = 0;
      }
      }
      if( k2 == yy )
      {
      k2 = 0;
      EJ = 0;
      }
      Buffer[ie] = B[xc - ie];
      ie++;
      }
      //                                           (   - SMA  EMA )
      int nb = xc - MA_period - 1;
      double vol;
      int iz;
      while( nb >= 0 )
      {
      if( EMA_true_SMA_false == false )
      {
      vol = 0;
      for( iz = nb; iz <= nb + MA_period - 1; iz++ )
      {
      vol = vol + Buffer[iz];
      }
      if( MA_period != 0 )
      {
      Buffer1[nb] = vol / MA_period;         //    
      }
      }
      else
      {
      if( EMA_true_SMA_false == true )
      {
      if( nb == xc - MA_period - 1 )
      { 
      Buffer1[nb + 1] = Buffer[nb + 1];
      }                                      //    
      Buffer1[nb]=( ( MA_period - 1 ) * Buffer1[nb + 1] + 2 * Buffer[nb] ) / ( MA_period + 1 );
      }
      }
      //---
      if( Bars - nb - 1 < MA_period )
      {
      Buffer1[nb] = 0;
      SetIndexEmptyValue( 1, 0.0 );
      }
      nb--;
      }
      //----                                        //    F
      int h = 1;
      double TWR = 1;
      double HPR;
      double g;
      double f;
      double F;
      double G;
      while( h < 99 )
      {
      f = f + 0.01;                                 //  HPR    1 %
      int o = 1;
      int i9 = z;
      while( o <= i9 )
      {
      if( Ll != 0 )
      { 
      HPR = 1 - f * T[o] / Ll;                      // HPR -   /   
      }                                             //   
      TWR  = TWR * HPR;                             //    - TWR
      o++;                                          //      T[]
      }
      G = MathPow( TWR, MathPow( z, -1 ) );         //     TWR
      if( G <= g )                                  //   G   
      {
      F = 100 * f - 1;                              //     F
      break;                                        //     
      }
      g = G;
      h++;
      TWR = 1;                                      //     o <= i9  TWR  1
      }
      //---
      if( ( Total_long != 0 ) && ( Total_short != 0 ) )
      {
      double pctLong = 100 * long / Total_long;           //        
      double pctShort = 100 * short / Total_short;        //        
      }
      double Gp = profit;                                 //     Gross profit
      double Gl = loss;                                   //     Gross loss
      double TN = profit - loss;                          //     Total Net Profit
      if( ( nles != 0 ) && ( nprofi != 0 ) )
      {
      double alt = loss / nles;                           //     Average loss trade
      double apt = profit / nprofi;                       //     Average profit trade
      }
      double total = z;                                   //     Total trades
      if( ( total != 0 ) && ( cn != 0 ) && ( gb != 0 ) )
      {
      double EP = TN / total;                             //      Expected Payoff
      double acw = nprofi / cn;                           //       Average consecutive wins
      double acl = nles / gb;                             //       Average consecutive losses
      double won = 100 * nprofi / total;                  //       
      double lS = 100 * nles / total;                     //       
      }
      if( ( alt != 0 ) && ( loss != 0 ) )
      {
      double ME = 0.01 * ( 1 + apt / alt ) * won - 1;     //    Mathematical xpectation
      double pf = profit / loss;                          //        Profit factor
      }
      //---
      double nt1pct = 100 * NT1 / ( balance - NT1 );      //    /  
      double nw2pct = 100 * NW2 / ( balance - NW2 );      //   /   
      double nm3pct = 100 * NM3 / ( balance - NM3 );      //   /   
      SetIndexDrawBegin( 0, Bars - xc );                  //        
      SetIndexDrawBegin( 1, Bars - xc + MA_period );      //         
      //---
      Comment( " Profit factor   "+DoubleToStr( pf, 2 )+" ", //  
      "\n ", "Profit trades ( % of total )   "+DoubleToStr( nprofi, 0 )+" ("+DoubleToStr( won, 2 )+" %) ",
      "\n ", "Loss trades ( % of total )   "+DoubleToStr( nles, 0 )+" ("+DoubleToStr( lS, 2 )+" %) ",
      "\n ", "Total trades   "+z+" ",
      "\n ", "Short Positions (won %)   "+Total_short+" ("+DoubleToStr( pctShort, 2 )+" %) ",
      "\n ", "Long Positions (won %)   "+Total_long+" ("+DoubleToStr( pctLong, 2 )+" %) ",
      "\n ", "Gross Profit    "+DoubleToStr( Gp, 2 )+" ",
      "\n ", "Gross Loss    "+DoubleToStr( Gl, 2 )+" ",
      "\n ", "Total Net Profit    "+DoubleToStr( TN, 2 )+" ",
      "\n ", "Expected Payoff   "+DoubleToStr( EP, 2 )+" ",
      "\n ", "Mathematical xpectation   "+DoubleToStr( ME, 2 )+"",
      "\n ", "Optimum fraction  F   "+DoubleToStr( F, 0 )+" % ",
      "\n ", "Current Drowdown  "+DoubleToStr( Dd, 2 )+"  ("+DoubleToStr( u, 2 )+" %)",
      "\n ", "Net Profit today (%)  "+DoubleToStr( NT1, 2 )+"  ("+DoubleToStr( nt1pct, 2 )+" %)", 
      "\n ", "Net Profit this week (%)  "+DoubleToStr( NW2, 2 )+"  ("+DoubleToStr( nw2pct, 2 )+" %)",
      "\n ", "Net Profit this month (%)  "+DoubleToStr( NM3, 2 )+"  ("+DoubleToStr( nm3pct, 2 )+" %)",
      "\n ", "Largest profit trade   "+DoubleToStr( Lp, 2 )+" ",
      "\n ", "Largest loss trade   "+DoubleToStr( Ll, 2 )+" ",
      "\n ", "Average profit trade   "+DoubleToStr( apt, 2 )+" ",
      "\n ", "Average loss trade   "+DoubleToStr( -alt, 2 )+" ",
      "\n ", "Average consecutive wins   "+DoubleToStr( acw, 0 )+" ",
      "\n ", "Average consecutive losses   "+DoubleToStr( acl, 0 )+" ",
      "\n ", "Maximum consecutive wins($)    "+yy+" ("+DoubleToStr( fgh, 2 )+") ",
      "\n ", "Maximum consecutive losses($)   "+xx+" ("+DoubleToStr( css, 2 )+") ",
      "\n ", "Maximal consecutive profit (count)   "+DoubleToStr( en, 2 )+"  ("+es+")",
      "\n ", "Maximal consecutive loss  (count)   "+DoubleToStr( mk, 2 )+"  ("+re+")" );
      }
      else                                                                //    FP
      {
   	if( Get_report == false )
   	{
      double last_trade;
      int ei;
      while( ei < OrdersHistoryTotal( ) )
      {
      if( OrderSelect( ei, SELECT_BY_POS, MODE_HISTORY ) == true )
      {
      if( OrderType( ) <= 1 )
      {
      last_trade = OrderSwap( ) + OrderProfit( ) + OrderCommission( );    //  
      }
      }
      ei++;
      }
		double minlot = MarketInfo( Symbol( ), MODE_MINLOT );               //   
		double Delta;
		if( last_trade < 0 )                                                //      
		{
		Delta = Delta_Decrease;                                             //     
		}
		else
		{
		if( last_trade >= 0 )                                               //    0   
		{
		Delta = Delta_Growth;                                               //    
		}
		} 
		double fp = ( MathSqrt( 0.25 + 2 * ( balance - Delta ) / Delta ) + 0.5 );
	   double lot = NormalizeDouble( minlot * MathRound( fp - 0.5 ), 2 );
		string dD = "Delta_Decrease   "+DoubleToStr( Delta_Decrease, 2 )+"";
		string dG = "Delta_Growth     "+DoubleToStr( Delta_Growth, 2 )+"";
		string v = "Lot                      "+DoubleToStr( lot, 2 )+" ";
      Comment( " "+v+"", "\n ", dG, "\n ", dD );
		}
      }

      return(0);
      }





